<?php

namespace App\Http\Controllers;

//use App\BookingReceipts;
use DB;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;

class BookingReceiptsController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {


        $lkp_paymenttype = DB::select('SELECT id,paymentType from lkp_paymenttype order by paymentType');
        $lkp_paymentstatus = DB::select('SELECT * from lkp_paymentstatus order by id');


        $Select_db = DB::table('booking_receipts')->select('booking_receipts.id as id', 'bookingId', 'booking_receipts.passengerId', 'passengers.name as passenger_name',
            'booking_receipts.driverId as driverId', 'drivers.name as driver_name',
            'totalAmountPaid', 'companyProfit', 'driverPercentage', 'driverProfit', 'vatTax',
            'paymentStatusId', 'status', 'paymentTypeId', 'paymentType', 'booking_receipts.created_at', 'booking_receipts.updated_at')
            ->leftJoin('drivers', 'booking_receipts.driverId', '=', 'drivers.id')
            ->leftJoin('passengers', 'booking_receipts.passengerId', '=', 'passengers.id')
            ->leftJoin('lkp_paymenttype', 'booking_receipts.paymentTypeId', '=', 'lkp_paymenttype.id')
            ->leftJoin('lkp_paymentstatus', 'booking_receipts.paymentStatusId', '=', 'lkp_paymentstatus.id')
            ->where('booking_receipts.companyId', Auth::user()->companyId);


        if (request()->ajax()) {


            if (!empty($request->filter_bookingId)) {
                $Select_db->where('booking_receipts.bookingId', $request->filter_bookingId);
            }
            if (!empty($request->filter_passengerId)) {
                $Select_db->where('booking_receipts.passengerId', $request->filter_passengerId);
            }
            if (!empty($request->filter_driverId)) {
                $Select_db->where('booking_receipts.driverId', $request->filter_driverId);
            }
            if (!empty($request->filter_totalAmountPaid)) {
                $Select_db->where('booking_receipts.totalAmountPaid', $request->filter_totalAmountPaid);
            }
            if (!empty($request->filter_companyProfit)) {
                $Select_db->where('booking_receipts.companyProfit', $request->filter_companyProfit);
            }
            if (!empty($request->filter_driverPercentage)) {
                $Select_db->where('booking_receipts.driverPercentage', $request->filter_driverPercentage);
            }
            if (!empty($request->filter_driverProfit)) {
                $Select_db->where('booking_receipts.driverProfit', $request->filter_driverProfit);
            }
            if (!empty($request->filter_vatTax)) {
                $Select_db->where('booking_receipts.vatTax', $request->filter_vatTax);
            }
            if (!empty($request->filter_paymentStatusId)) {
                $Select_db->where('booking_receipts.paymentStatusId', $request->filter_paymentStatusId);
            }
            if (!empty($request->filter_paymentTypeId)) {
                $Select_db->where('booking_receipts.paymentTypeId', $request->filter_paymentTypeId);
            }
            if (!empty($request->filter_created_at)) {
                $filter_created_at = explode(" - ", $request->filter_created_at);
                $Select_db->whereRaw("CAST(booking_receipts.created_at as date) between STR_TO_DATE('$filter_created_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_created_at[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_updated_at)) {
                $filter_updated_at = explode(" - ", $request->filter_updated_at);
                $Select_db->whereRaw("CAST(booking_receipts.updated_at as date) between STR_TO_DATE('$filter_updated_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_updated_at[1]','%d/%m/%Y')");
            }
            $data = $Select_db->get();
            return datatables()->of($data)->make(true);
        }

        $data = $Select_db->get();
        //$BookingReceipts = BookingReceipts::orderBy('created_at', 'desc')->paginate(10);
        return view('BookingReceipts.index')->with(compact('lkp_paymentstatus'))->with(compact('lkp_paymenttype'));
        //return view('custom_search', compact('country_name'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public
    function create()
    {


    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public
    function store(Request $request)
    {

    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public
    function show($id)
    {
        //return $id;

        $BookingReceipts = DB::table('booking_receipts')->select('booking_receipts.id as id', 'bookingId', 'passengerId', 'passengers.name as passenger_name',
            'booking_receipts.driverId as driverId', 'drivers.name as driver_name',
            'totalAmountPaid', 'companyProfit', 'driverPercentage', 'driverProfit', 'vatTax',
            'paymentStatusId', 'status', 'paymentTypeId', 'paymentType', 'booking_receipts.created_at', 'booking_receipts.updated_at')
            ->leftJoin('drivers', 'booking_receipts.driverId', '=', 'drivers.id')
            ->leftJoin('passengers', 'booking_receipts.passengerId', '=', 'passengers.id')
            ->leftJoin('lkp_paymenttype', 'booking_receipts.paymentTypeId', '=', 'lkp_paymenttype.id')
            ->leftJoin('lkp_paymentstatus', 'booking_receipts.paymentStatusId', '=', 'lkp_paymentstatus.id')
            ->where('booking_receipts.companyId', Auth::user()->companyId)
            ->where('booking_receipts.id', $id)
            ->first();
        return view('BookingReceipts.show')->with(compact('BookingReceipts'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public
    function edit($id)
    {

    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public
    function update(Request $request, $id)
    {

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public
    function destroy($id)
    {

    }

}
