<?php

namespace App\Http\Controllers;

use App\DriverVehicles;
use DB;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

class DriverVehiclesController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {


        $cartypes = DB::select('SELECT id,carName from lkp_cartypes order by carName');
        $carbrands = DB::select('SELECT id,name_en from lkp_carbrands order by name_en');
        $vehicleplatetype = DB::select('SELECT id,englishName from lkp_vehicleplatetype order by id');
        $validity = DB::select('SELECT id,status from lkp_validity order by status');
        $users = DB::select('SELECT id,name from users order by name');

        $Select_db = DB::table('driver_vehicles')
            ->select('driver_vehicles.id as id', 'model', 'driver_vehicles.driverId', 'drivers.name', 'carName',
                'lkp_carbrands.name_en as Brand_En',
                'lkp_carbrandsub.name_en as BrandSub_En', 'sequenceNumber',
                DB::raw("CONCAT(plateLetterRight,' ',plateLetterMiddle,' ',plateLetterLeft,' ',plateNumber )  AS plate"),
                'englishName', 'driver_vehicles.validityId', 'lkp_validity.status as validity_status',
                'driver_vehicles.validity_dt', 'users.name as validity_by_name',
                'driver_vehicles.created_at', 'driver_vehicles.updated_at')
            ->leftJoin('drivers', 'driver_vehicles.driverId', '=', 'drivers.id')
            ->leftJoin('lkp_cartypes', 'driver_vehicles.carTypeId', '=', 'lkp_cartypes.id')
            ->leftJoin('lkp_carbrands', 'driver_vehicles.carbrand_Id', '=', 'lkp_carbrands.id')
            ->leftJoin('lkp_carbrandsub', 'driver_vehicles.carbrandsub_Id', '=', 'lkp_carbrandsub.id')
            ->leftJoin('lkp_vehicleplatetype', 'driver_vehicles.plateTypeId', '=', 'lkp_vehicleplatetype.id')
            ->leftJoin('lkp_validity', 'driver_vehicles.validityId', '=', 'lkp_validity.id')
            ->leftJoin('users', 'driver_vehicles.validity_by_id', '=', 'users.id')
            ->where('driver_vehicles.companyId', Auth::user()->companyId);;
        if (request()->ajax()) {

            if (!empty($request->filter_driverId)) {
                $Select_db->where('driverId', $request->filter_driverId);
            }
            if (!empty($request->Driver_ID)) {
                $Select_db->where('driverId', $request->Driver_ID);
            }
            if (!empty($request->filter_model)) {
                $Select_db->whereRaw("UPPER(model) LIKE '%".strtoupper($request->filter_model)."%'");
            }
            if (!empty($request->filter_carTypeId)) {
                $Select_db->where('carTypeId', $request->filter_carTypeId);
            }
            if (!empty($request->filter_carbrand_Id)) {
                $Select_db->where('carbrand_Id', $request->filter_carbrand_Id);
            }
            if (!empty($request->filter_carbrandsub_Id)) {
                $Select_db->where('carbrandsub_Id', $request->filter_carbrandsub_Id);
            }
            if (!empty($request->filter_colour)) {
                $Select_db->whereRaw("UPPER(colour) LIKE '%".strtoupper($request->filter_colour)."%'");
            }
            if (!empty($request->filter_sequenceNumber)) {
                $Select_db->whereRaw("UPPER(sequenceNumber) LIKE '%".strtoupper($request->filter_sequenceNumber)."%'");
            }
            if (!empty($request->filter_plateLetterRight)) {
                $Select_db->whereRaw("UPPER(plateLetterRight) = '".strtoupper($request->filter_plateLetterRight)."'");
            }
            if (!empty($request->filter_plateLetterMiddle)) {
                $Select_db->whereRaw("UPPER(plateLetterMiddle) = '".strtoupper($request->filter_plateLetterMiddle)."'");
            }
            if (!empty($request->filter_plateLetterLeft)) {
                $Select_db->whereRaw("UPPER(plateLetterLeft) = '".strtoupper($request->filter_plateLetterLeft)."'");
            }
            if (!empty($request->filter_plateTypeId)) {
                $Select_db->where('plateTypeId', $request->filter_plateTypeId);
            }
            if (!empty($request->filter_plateNumber)) {
                $Select_db->where('plateNumber', $request->filter_plateNumber);
            }
            if (!empty($request->filter_vehicleReferenceNumber)) {
                $Select_db->where('vehicleReferenceNumber', $request->filter_vehicleReferenceNumber);
            }
            if (!empty($request->filter_validityId)) {
                $Select_db->where('driver_vehicles.validityId', $request->filter_validityId);
            }
            if (!empty($request->filter_validity_dt)) {
                $filter_validity_dt = explode(" - ", $request->filter_validity_dt);
                $Select_db->whereRaw("CAST(driver_vehicles.validity_dt as date) between STR_TO_DATE('$filter_validity_dt[0]','%d/%m/%Y') and STR_TO_DATE('$filter_validity_dt[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_validity_by_id)) {
                $Select_db->where('driver_vehicles.validity_by_id', $request->filter_validity_by_id);
            }
            if (!empty($request->filter_created_at)) {
                $filter_created_at = explode(" - ", $request->filter_created_at);
                $Select_db->whereRaw("CAST(driver_vehicles.created_at as date) between STR_TO_DATE('$filter_created_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_created_at[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_updated_at)) {
                $filter_updated_at = explode(" - ", $request->filter_updated_at);
                $Select_db->whereRaw("CAST(driver_vehicles.updated_at as date) between STR_TO_DATE('$filter_updated_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_updated_at[1]','%d/%m/%Y')");
            }


            $data = $Select_db->get();
            return datatables()->of($data)->make(true);
        }

        $data = $Select_db->get();
        //$DriverVehicles = DriverVehicles::orderBy('created_at', 'desc')->paginate(10);
        if (Route::getFacadeRoot()->current()->uri() == 'DriverVehicleWindow') {
            $view = "DriverVehicleWindow";
        } elseif (Route::getFacadeRoot()->current()->uri() == 'DriverVehicles') {
            $view = "index";
        }
        return view('DriverVehicles.'.$view)->with(compact('cartypes'))
            ->with(compact('carbrands'))->with(compact('vehicleplatetype'))
            ->with(compact('validity'))->with(compact('users'));

        //return view('custom_search', compact('country_name'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        $cartypes = DB::select('SELECT id,carName from lkp_cartypes order by carName');
        $carbrands = DB::select('SELECT id,name_en from lkp_carbrands order by name_en');
        $vehicleplatetype = DB::select('SELECT id,englishName from lkp_vehicleplatetype order by id');
        $validity = DB::select('SELECT id,status from lkp_validity order by status');

        return view('DriverVehicles.create')->with(compact('cartypes'))->with(compact('carbrands'))->with(compact('vehicleplatetype'))->with(compact('validity'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        //
        /* $this->validate($request, [
             'name' => ['required', 'string', 'max:255'],
             'email' => ['required', 'string', 'email', 'max:255', 'unique:DriverVehicles'],
             'password' => ['required', 'string', 'min:8', 'confirmed'],

         ]);
         */
        $DriverVehicles = new DriverVehicles;
        $DriverVehicles->driverId = $request->input('driverId');
        $DriverVehicles->model = $request->input('model');
        $DriverVehicles->carTypeId = $request->input('carTypeId');
        $DriverVehicles->carbrand_Id = $request->input('carbrand_Id');
        $DriverVehicles->carbrandsub_Id = $request->input('carbrandsub_Id');
        $DriverVehicles->colour = $request->input('colour');
        $DriverVehicles->sequenceNumber = $request->input('sequenceNumber');
        $DriverVehicles->plateLetterRight = $request->input('plateLetterRight');
        $DriverVehicles->plateLetterMiddle = $request->input('plateLetterMiddle');
        $DriverVehicles->plateLetterLeft = $request->input('plateLetterLeft');
        $DriverVehicles->plateTypeId = $request->input('plateTypeId');
        $DriverVehicles->plateNumber = $request->input('plateNumber');
        $DriverVehicles->vehicleReferenceNumber = $request->input('vehicleReferenceNumber');
        $DriverVehicles->validityId = $request->input('validityId');
        $DriverVehicles->validity_dt = date("Y-m-d H:i:s");
        $DriverVehicles->validity_by_id = Auth::user()->id;
        $DriverVehicles->companyId = Auth::user()->companyId;
        $DriverVehicles->save();

        return redirect('/DriverVehicles')->with('success', 'Done successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //return $id;



        $DriverVehicle = DB::table('driver_vehicles')
            ->select('driver_vehicles.id as id', 'model', 'drivers.name', 'carName', 'lkp_carbrands.name_en as Brand_En',
                'lkp_carbrandsub.name_en as BrandSub_En', 'colour', 'sequenceNumber',
                'plateLetterRight', 'plateLetterMiddle', 'plateLetterLeft', 'plateNumber',
                'englishName', 'vehicleReferenceNumber', 'driver_vehicles.validityId',
                'driver_vehicles.validity_dt', 'users.name as validity_by_name',
                'lkp_validity.status as validity_status','driver_vehicles.created_at', 'driver_vehicles.updated_at')
            ->leftJoin('drivers', 'driver_vehicles.driverId', '=', 'drivers.id')
            ->leftJoin('lkp_cartypes', 'driver_vehicles.carTypeId', '=', 'lkp_cartypes.id')
            ->leftJoin('lkp_carbrands', 'driver_vehicles.carbrand_Id', '=', 'lkp_carbrands.id')
            ->leftJoin('lkp_carbrandsub', 'driver_vehicles.carbrandsub_Id', '=', 'lkp_carbrandsub.id')
            ->leftJoin('lkp_vehicleplatetype', 'driver_vehicles.plateTypeId', '=', 'lkp_vehicleplatetype.id')
            ->leftJoin('lkp_validity', 'driver_vehicles.validityId', '=', 'lkp_validity.id')
            ->leftJoin('users', 'driver_vehicles.validity_by_id', '=', 'users.id')
            ->where('driver_vehicles.companyId', Auth::user()->companyId)
            ->where('driver_vehicles.id', $id)
            ->first();
        return view('DriverVehicles.show')->with(compact('DriverVehicle'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $cartypes = DB::select('SELECT id,carName from lkp_cartypes order by carName');
        $carbrands = DB::select('SELECT id,name_en from lkp_carbrands order by name_en');
        $carbrandsubs = DB::select('SELECT lkp_carbrandsub.id,lkp_carbrandsub.name_en from lkp_carbrandsub
        inner join lkp_carbrands on lkp_carbrands.id=lkp_carbrandsub.brand_id
        inner join driver_vehicles on driver_vehicles.carbrand_Id =lkp_carbrands.id
        where driver_vehicles.id='.$id.'
        order by lkp_carbrandsub.name_en');
        $vehicleplatetype = DB::select('SELECT id,englishName from lkp_vehicleplatetype order by id');
        $validity = DB::select('SELECT id,status from lkp_validity order by status');

        $DriverVehicles = DB::select('SELECT driver_vehicles.*,name from driver_vehicles
       left join drivers on drivers.id=driver_vehicles.driverId
       where driver_vehicles.companyId='.Auth::user()->companyId.' and driver_vehicles.id='.$id);
        //DriverVehicles::find($id);
        return view('DriverVehicles.edit')->with(compact('DriverVehicles'))->with(compact('cartypes'))->with(compact('carbrands'))->with(compact('vehicleplatetype'))->with(compact('validity'))->with(compact('carbrandsubs'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //'password' => ['required', 'string', 'min:8', 'confirmed'],
        /* $this->validate($request, [
             'name' => ['required', 'string', 'max:255'],
             'email' => ['required', 'string', 'email', 'max:255'],

         ]);
        */
        $DriverVehicles = DriverVehicles::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        $DriverVehicles->driverId = $request->input('driverId');
        $DriverVehicles->model = $request->input('model');
        $DriverVehicles->carTypeId = $request->input('carTypeId');
        $DriverVehicles->carbrand_Id = $request->input('carbrand_Id');
        $DriverVehicles->carbrandsub_Id = $request->input('carbrandsub_Id');
        $DriverVehicles->colour = $request->input('colour');
        $DriverVehicles->sequenceNumber = $request->input('sequenceNumber');
        $DriverVehicles->plateLetterRight = $request->input('plateLetterRight');
        $DriverVehicles->plateLetterMiddle = $request->input('plateLetterMiddle');
        $DriverVehicles->plateLetterLeft = $request->input('plateLetterLeft');
        $DriverVehicles->plateTypeId = $request->input('plateTypeId');
        $DriverVehicles->plateNumber = $request->input('plateNumber');
        $DriverVehicles->vehicleReferenceNumber = $request->input('vehicleReferenceNumber');

        if ($DriverVehicles->validityId <> $request->input('validityId')) {
            $DriverVehicles->validity_dt = date("Y-m-d H:i:s");
            $DriverVehicles->validity_by_id = Auth::user()->id;
        }
        $DriverVehicles->validityId = $request->input('validityId');
        $DriverVehicles->save();

        return redirect('/DriverVehicles')->with('success', 'Done successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {

        $DriverVehicles = DriverVehicles::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        // if(auth()->DriverVehicles()->id !== $DriverVehicles->DriverVehicles_id){
        //    return redirect('/DriverVehicles')->with('error','Unauthorized');
        // }

        if ($DriverVehicles->logo != 'noImage.jpg') {
            Storage::delete('public/app/storage'.$DriverVehicles->logo);

        }

        $DriverVehicles->delete();

        return redirect('/DriverVehicles')->with('success', 'Done successfully');
    }

    public function getcarbrandsub($barand_id)
    {
        $Select_db = DB::table('lkp_carbrandsub')
            ->select('id', 'name_en')
            ->where('brand_id', $barand_id);
        return response()->json($Select_db->get(), 200);
    }
}
