<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Drivers;
use DB;
use Illuminate\Support\Facades\Auth;

class DriverWindowController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    public function index(Request $request)
    {


        $countries = DB::select('SELECT id,country_en from lkp_country order by country_en');
        $driverstatus = DB::select('SELECT id,status from lkp_driverstatus order by id');

        $Select_db = DB::table('Drivers')
            ->select('Drivers.id as id', 'name', 'mobileNumber', 'emailAddress', 'dateOfBirthHijri', 'dateOfBirthGregorian'
                , 'country_en', 'profileImage',
                'identityNumber', 'identityProofImage', 'licenseProofImage', 'eligibilityExpiryDate', 'lkp_gender.gender as gender_name', 'address',
                'latLng', 'created_at', 'updated_at',
                'loginStatusId', 'lkp_login.status as loginStatus_name', 'driverStatusId', 'lkp_driverstatus.status',
                'rating', 'completeTrips', 'cancelledTrips', 'validityId', 'lkp_validity.status as validity_name')
            ->leftJoin('lkp_driverstatus', 'Drivers.driverStatusId', '=', 'lkp_driverstatus.id')
            ->leftJoin('lkp_country', 'Drivers.nationalityId', '=', 'lkp_country.id')
            ->leftJoin('lkp_validity', 'drivers.validityId', '=', 'lkp_validity.id')
            ->leftJoin('lkp_login', 'drivers.loginStatusId', '=', 'lkp_login.id')
            ->leftJoin('lkp_gender', 'drivers.genderId', '=', 'lkp_gender.id')
            ->where('drivers.companyId', Auth::user()->companyId);

        if (request()->ajax()) {

            if (!empty($request->filter_name)) {
                $Select_db->whereRaw("UPPER(name) LIKE '%" . strtoupper($request->filter_name) . "%'");
            }
            if (!empty($request->filter_mobileNumber)) {
                $Select_db->whereRaw("UPPER(mobileNumber) LIKE '%" . strtoupper($request->filter_mobileNumber) . "%'");
            }
            if (!empty($request->filter_emailAddress)) {
                $Select_db->whereRaw("UPPER(emailAddress) LIKE '%" . strtoupper($request->filter_emailAddress) . "%'");
            }
            if (!empty($request->filter_dateOfBirthHijri)) {
                $filter_dateOfBirthHijri = explode(" - ", $request->filter_dateOfBirthHijri);
                $Select_db->whereRaw("CAST(dateOfBirthHijri as date) between STR_TO_DATE('$filter_dateOfBirthHijri[0]','%d/%m/%Y') and STR_TO_DATE('$filter_dateOfBirthHijri[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_dateOfBirthGregorian)) {
                $filter_dateOfBirthGregorian = explode(" - ", $request->filter_dateOfBirthGregorian);
                $Select_db->whereRaw("CAST(dateOfBirthGregorian as date) between STR_TO_DATE('$filter_dateOfBirthGregorian[0]','%d/%m/%Y') and STR_TO_DATE('$filter_dateOfBirthGregorian[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_nationalityId)) {
                $Select_db->where('nationalityId', $request->filter_nationalityId);
            }
            if (!empty($request->filter_identityNumber)) {
                $Select_db->whereRaw("UPPER(identityNumber) LIKE '%" . strtoupper($request->filter_identityNumber) . "%'");
            }
            if (!empty($request->filter_eligibilityExpiryDate)) {
                $filter_eligibilityExpiryDate = explode(" - ", $request->filter_eligibilityExpiryDate);
                $Select_db->whereRaw("CAST(eligibilityExpiryDate as date) between STR_TO_DATE('$filter_eligibilityExpiryDate[0]','%d/%m/%Y') and STR_TO_DATE('$filter_eligibilityExpiryDate[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_driverStatusId)) {
                $Select_db->where('driverStatusId', $request->filter_driverStatusId);
            }
            if (!empty($request->filter_gender)) {
                $Select_db->where('gender', $request->filter_gender);
            }
            if (!empty($request->filter_address)) {
                $Select_db->whereRaw("UPPER(address) LIKE '%" . strtoupper($request->filter_address) . "%'");
            }
            if (!empty($request->filter_rating)) {
                $Select_db->where('rating', $request->filter_rating);
            }
            if (!empty($request->filter_loginStatus)) {
                $Select_db->where('loginStatus', $request->filter_loginStatus);
            }
            if (!empty($request->filter_completeTrips)) {
                $Select_db->where('completeTrips', $request->filter_completeTrips);
            }
            if (!empty($request->filter_cancelledTrips)) {
                $Select_db->where('cancelledTrips', $request->filter_cancelledTrips);
            }
            if (!empty($request->filter_validity)) {
                $Select_db->where('validity', $request->filter_validity);
            }
            if (!empty($request->filter_created_at)) {
                $filter_created_at = explode(" - ", $request->filter_created_at);
                $Select_db->whereRaw("CAST(created_at as date) between STR_TO_DATE('$filter_created_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_created_at[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_updated_at)) {
                $filter_updated_at = explode(" - ", $request->filter_updated_at);
                $Select_db->whereRaw("CAST(updated_at as date) between STR_TO_DATE('$filter_updated_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_updated_at[1]','%d/%m/%Y')");
            }


            $data = $Select_db->get();
            return datatables()->of($data)->make(true);
        }

        $data = $Select_db->get();
        //$Drivers = Drivers::orderBy('created_at', 'desc')->paginate(10);
        return view('Drivers.DriverWindow')->with(compact('countries'))->with(compact('driverstatus'));
        //return view('custom_search', compact('country_name'));
    }


}
