<?php

namespace App\Http\Controllers;

use App\Drivers;
use DB;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;

class DriversController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {


        $countries = DB::select('SELECT id,country_en from lkp_country order by country_en');
        $driverstatus = DB::select('SELECT id,status from lkp_driverstatus order by id');
        $users = DB::select('SELECT id,name from users order by name');

        $Select_db = DB::table('drivers')
            ->select('drivers.id as id', 'drivers.name', 'mobileNumber', 'loginStatusId', 'driverStatusId',
                'lkp_driverstatus.status', 'rating', 'completeTrips', 'cancelledTrips', 'validityId', 'validity_dt',
                'users.name as validity_by_name',
                'lkp_validity.status as validity_name', 'drivers.created_at', 'drivers.updated_at')
            ->leftJoin('lkp_driverstatus', 'drivers.driverStatusId', '=', 'lkp_driverstatus.id')
            ->leftJoin('lkp_validity', 'drivers.validityId', '=', 'lkp_validity.id')
            ->leftJoin('users', 'drivers.validity_by_id', '=', 'users.id')
            ->where('drivers.companyId', Auth::user()->companyId);

        if (request()->ajax()) {

            if (!empty($request->filter_name)) {
                $Select_db->whereRaw("UPPER(name) LIKE '%".strtoupper($request->filter_name)."%'");
            }
            if (!empty($request->filter_mobileNumber)) {
                $Select_db->whereRaw("UPPER(mobileNumber) LIKE '%".strtoupper($request->filter_mobileNumber)."%'");
            }
            if (!empty($request->filter_emailAddress)) {
                $Select_db->whereRaw("UPPER(emailAddress) LIKE '%".strtoupper($request->filter_emailAddress)."%'");
            }
            if (!empty($request->filter_dateOfBirthHijri)) {
                $filter_dateOfBirthHijri = explode(" - ", $request->filter_dateOfBirthHijri);
                $Select_db->whereRaw("CAST(dateOfBirthHijri as date) between STR_TO_DATE('$filter_dateOfBirthHijri[0]','%d/%m/%Y') and STR_TO_DATE('$filter_dateOfBirthHijri[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_dateOfBirthGregorian)) {
                $filter_dateOfBirthGregorian = explode(" - ", $request->filter_dateOfBirthGregorian);
                $Select_db->whereRaw("CAST(dateOfBirthGregorian as date) between STR_TO_DATE('$filter_dateOfBirthGregorian[0]','%d/%m/%Y') and STR_TO_DATE('$filter_dateOfBirthGregorian[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_nationalityId)) {
                $Select_db->where('nationalityId', $request->filter_nationalityId);
            }
            if (!empty($request->filter_identityNumber)) {
                $Select_db->whereRaw("UPPER(identityNumber) LIKE '%".strtoupper($request->filter_identityNumber)."%'");
            }
            if (!empty($request->filter_eligibilityExpiryDate)) {
                $filter_eligibilityExpiryDate = explode(" - ", $request->filter_eligibilityExpiryDate);
                $Select_db->whereRaw("CAST(eligibilityExpiryDate as date) between STR_TO_DATE('$filter_eligibilityExpiryDate[0]','%d/%m/%Y') and STR_TO_DATE('$filter_eligibilityExpiryDate[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_driverStatusId)) {
                $Select_db->where('driverStatusId', $request->filter_driverStatusId);
            }
            if (!empty($request->filter_gender)) {
                $Select_db->where('genderId', $request->filter_gender);
            }
            if (!empty($request->filter_address)) {
                $Select_db->whereRaw("UPPER(address) LIKE '%".strtoupper($request->filter_address)."%'");
            }
            if (!empty($request->filter_rating)) {
                $Select_db->where('rating', $request->filter_rating);
            }
            if (!empty($request->filter_loginStatus)) {
                $Select_db->where('loginStatusId', $request->filter_loginStatus);
            }
            if (!empty($request->filter_completeTrips)) {
                $Select_db->where('completeTrips', $request->filter_completeTrips);
            }
            if (!empty($request->filter_cancelledTrips)) {
                $Select_db->where('cancelledTrips', $request->filter_cancelledTrips);
            }
            if (!empty($request->filter_validity)) {
                $Select_db->where('validityId', $request->filter_validity);
            }
            if (!empty($request->filter_validity_dt)) {
                $filter_validity_dt = explode(" - ", $request->filter_validity_dt);
                $Select_db->whereRaw("CAST(drivers.validity_dt as date) between STR_TO_DATE('$filter_validity_dt[0]','%d/%m/%Y') and STR_TO_DATE('$filter_validity_dt[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_validity_by_id)) {
                $Select_db->where('validity_by_id', $request->filter_validity_by_id);
            }
            if (!empty($request->filter_created_at)) {
                $filter_created_at = explode(" - ", $request->filter_created_at);
                $Select_db->whereRaw("CAST(drivers.created_at as date) between STR_TO_DATE('$filter_created_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_created_at[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_updated_at)) {
                $filter_updated_at = explode(" - ", $request->filter_updated_at);
                $Select_db->whereRaw("CAST(drivers.updated_at as date) between STR_TO_DATE('$filter_updated_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_updated_at[1]','%d/%m/%Y')");
            }


            $data = $Select_db->get();
            return datatables()->of($data)->make(true);
        }

        $data = $Select_db->get();
        //$Drivers = Drivers::orderBy('created_at', 'desc')->paginate(10);
        return view('Drivers.index')->with(compact('countries'))
            ->with(compact('driverstatus'))->with(compact('users'));
        //return view('custom_search', compact('country_name'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $countries = DB::select('SELECT id,country_en from lkp_country order by country_en');
        $driverstatus = DB::select('SELECT id,status from lkp_driverstatus order by id');
        return view('Drivers.create')->with(compact('countries'))->with(compact('driverstatus'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        //
        /* $this->validate($request, [
             'name' => ['required', 'string', 'max:255'],
             'email' => ['required', 'string', 'email', 'max:255', 'unique:Drivers'],
             'password' => ['required', 'string', 'min:8', 'confirmed'],

         ]);
         */
        $Drivers = new Drivers;
        $Drivers->name = $request->input('name');
        $Drivers->genderId = $request->input('genderId');
        $Drivers->emailAddress = $request->input('emailAddress');
        $Drivers->mobileNumber = $request->input('mobileNumber');
        $Drivers->nationalityId = $request->input('nationalityId');
        //$Drivers->ProfileImage = $request->input('ProfileImage');
        $Drivers->dateOfBirthHijri = (empty($request->input('dateOfBirthHijri'))) ? null : \DateTime::createFromFormat('d/m/Y',
            $request->input('dateOfBirthHijri'))->format('Y-m-d');
        $Drivers->dateOfBirthGregorian = (empty($request->input('dateOfBirthGregorian'))) ? null : \DateTime::createFromFormat('d/m/Y',
            $request->input('dateOfBirthGregorian'))->format('Y-m-d');
        $Drivers->identityNumber = $request->input('identityNumber');
        if (empty($request->input('eligibilityExpiryDate'))) {
            $eligibilityExpiryDate = null;
        } else {
            $eligibilityExpiryDate = \DateTime::createFromFormat('d/m/Y',
                $request->input('eligibilityExpiryDate'))->format('Y-m-d');
        }
        $Drivers->eligibilityExpiryDate = (empty($request->input('eligibilityExpiryDate'))) ? null : \DateTime::createFromFormat('d/m/Y',
            $request->input('eligibilityExpiryDate'))->format('Y-m-d');
        $Drivers->driverStatusId = $request->input('driverStatusId');
        $Drivers->loginStatusId = $request->input('loginStatusId');
        $Drivers->address = $request->input('address');
        $Drivers->validityId = $request->input('validityId');
        $Drivers->validity_dt = date("Y-m-d H:i:s");
        $Drivers->validity_by_id = Auth::user()->id;
        $Drivers->companyId = Auth::user()->companyId;
        $Drivers->save();

        return redirect('/Drivers')->with('success', 'Done successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //return $id;
        $Select_db = DB::table('drivers')
            ->select('drivers.id as id', 'drivers.name', 'mobileNumber', 'emailAddress', 'dateOfBirthHijri',
                'dateOfBirthGregorian', 'country_en', 'profileImage',
                'identityNumber', 'identityProofImage', 'licenseProofImage', 'eligibilityExpiryDate',
                'lkp_gender.gender as gender_name', 'address',
                'latLng', 'drivers.created_at', 'drivers.updated_at',
                'validity_dt', 'users.name as validity_by_name',
                'loginStatusId', 'lkp_login.status as loginStatus_name', 'driverStatusId', 'lkp_driverstatus.status',
                'rating', 'completeTrips', 'cancelledTrips', 'validityId', 'lkp_validity.status as validity_name',
                'totalTripFares', 'totalEarning', 'totalVatPaid', 'totalCompanyProfit', 'totalPay', 'currentEarning',
                'currentCompanyProfit', 'currentVat', 'credit', 'previousBalance')
            ->leftJoin('lkp_driverstatus', 'drivers.driverStatusId', '=', 'lkp_driverstatus.id')
            ->leftJoin('lkp_country', 'drivers.nationalityId', '=', 'lkp_country.id')
            ->leftJoin('lkp_validity', 'drivers.validityId', '=', 'lkp_validity.id')
            ->leftJoin('lkp_login', 'drivers.loginStatusId', '=', 'lkp_login.id')
            ->leftJoin('lkp_gender', 'drivers.genderId', '=', 'lkp_gender.id')
            ->leftJoin('driverwallet', 'drivers.id', '=', 'driverwallet.driverId')
            ->leftJoin('users', 'drivers.validity_by_id', '=', 'users.id')
            ->where('drivers.companyId', Auth::user()->companyId)
            ->where('drivers.id', $id);

        $Drivers = $Select_db->first();
        //$Drivers = Drivers::find($id);

        return view('Drivers.show')->with('Drivers', $Drivers);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $countries = DB::select('SELECT id,country_en from lkp_country order by country_en');
        $driverstatus = DB::select('SELECT id,status from lkp_driverstatus order by id');
        $Drivers = Drivers::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        return view('Drivers.edit')->with(compact('Drivers'))->with(compact('countries'))->with(compact('driverstatus'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //'password' => ['required', 'string', 'min:8', 'confirmed'],
        /* $this->validate($request, [
             'name' => ['required', 'string', 'max:255'],
             'email' => ['required', 'string', 'email', 'max:255'],

         ]);
        */


        $Drivers = Drivers::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        $Drivers->name = $request->input('name');
        $Drivers->genderId = $request->input('genderId');
        $Drivers->emailAddress = $request->input('emailAddress');
        $Drivers->mobileNumber = $request->input('mobileNumber');
        $Drivers->nationalityId = $request->input('nationalityId');
        //$Drivers->ProfileImage = $request->input('ProfileImage');
        $Drivers->dateOfBirthHijri = (empty($request->input('dateOfBirthHijri'))) ? null : \DateTime::createFromFormat('d/m/Y',
            $request->input('dateOfBirthHijri'))->format('Y-m-d');
        $Drivers->dateOfBirthGregorian = (empty($request->input('dateOfBirthGregorian'))) ? null : \DateTime::createFromFormat('d/m/Y',
            $request->input('dateOfBirthGregorian'))->format('Y-m-d');
        $Drivers->identityNumber = $request->input('identityNumber');
        if (empty($request->input('eligibilityExpiryDate'))) {
            $eligibilityExpiryDate = null;
        } else {
            $eligibilityExpiryDate = \DateTime::createFromFormat('d/m/Y',
                $request->input('eligibilityExpiryDate'))->format('Y-m-d');
        }
        $Drivers->eligibilityExpiryDate = (empty($request->input('eligibilityExpiryDate'))) ? null : \DateTime::createFromFormat('d/m/Y',
            $request->input('eligibilityExpiryDate'))->format('Y-m-d');
        $Drivers->driverStatusId = $request->input('driverStatusId');
        $Drivers->loginStatusId = $request->input('loginStatusId');
        $Drivers->address = $request->input('address');

        if ($Drivers->validityId <> $request->input('validityId')) {
            $Drivers->validity_dt = date("Y-m-d H:i:s");
            $Drivers->validity_by_id = Auth::user()->id;
        }
        $Drivers->validityId = $request->input('validityId');
        $Drivers->save();

        return redirect('/Drivers')->with('success', 'Done successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {

        $Drivers = Drivers::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        // if(auth()->Drivers()->id !== $Drivers->Drivers_id){
        //    return redirect('/Drivers')->with('error','Unauthorized');
        // }

        if ($Drivers->logo != 'noImage.jpg') {
            Storage::delete('public/app/storage'.$Drivers->logo);

        }

        $Drivers->delete();

        return redirect('/Drivers')->with('success', 'Done successfully');
    }
}
