<?php

namespace App\Http\Controllers;

use App\Passengers;
use DB;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;

class PassengersController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {

       // $p = DB::select('SELECT count(*) as CO from passengers')[0];
        //echo $p->CO;
       // exit;
        $Select_db = DB::table('passengers')
            ->select('passengers.id as id', 'name', 'lkp_gender.id as genderId', 'lkp_gender.gender as gender_name', 'email', 'mobile',
                'loginStatusId', 'lkp_login.status as loginStatus_name', 'created_at', 'deviceType', 'deviceType_name', 'validityId', 'lkp_validity.status as validity_name', 'profileImage')
            ->leftJoin('lkp_devicetype', 'passengers.deviceType', '=', 'lkp_devicetype.id')
            ->leftJoin('lkp_login', 'passengers.loginStatusId', '=', 'lkp_login.id')
            ->leftJoin('lkp_gender', 'passengers.genderId', '=', 'lkp_gender.id')
            ->leftJoin('lkp_validity', 'passengers.validityId', '=', 'lkp_validity.id');



        if (request()->ajax()) {

            if (!empty($request->filter_name)) {
                $Select_db->whereRaw("UPPER(name) LIKE '%" . strtoupper($request->filter_name) . "%'");
            }
            if (!empty($request->filter_email)) {
                $Select_db->whereRaw("UPPER(email) LIKE '%" . strtoupper($request->filter_email) . "%'");
            }
            if (!empty($request->filter_mobile)) {
                $Select_db->whereRaw("UPPER(mobile) LIKE '%" . strtoupper($request->filter_mobile) . "%'");
            }

            if (!empty($request->filter_deviceType)) {
                $Select_db->where('deviceType', $request->filter_deviceType);
            }
            if (!empty($request->filter_loginStatus)) {
                $Select_db->where('loginStatusId', $request->filter_loginStatus);
            }
            if (!empty($request->filter_validity)) {
                $Select_db->where('validityId', $request->filter_validity);
            }
            if (!empty($request->filter_gender)) {
                $Select_db->where('genderId', $request->filter_gender);
            }
            if (!empty($request->filter_created_at)) {
                $filter_created_at = explode(" - ", $request->filter_created_at);
                $Select_db->whereRaw("CAST(created_at as date) between STR_TO_DATE('$filter_created_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_created_at[1]','%d/%m/%Y')");
            }
            $data = $Select_db->get();
            return datatables()->of($data)->make(true);
        }

        $data = $Select_db->get();
        //$Passengers = Passengers::orderBy('created_at', 'desc')->paginate(10);
        return view('Passengers.index');
        //return view('custom_search', compact('country_name'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        //$Passengers = Passengers::all();
        return view('Passengers.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        //
        /* $this->validate($request, [
             'name' => ['required', 'string', 'max:255'],
             'email' => ['required', 'string', 'email', 'max:255', 'unique:Passengers'],
             'password' => ['required', 'string', 'min:8', 'confirmed'],

         ]);
         */
        $Passengers = new Passengers;
        $Passengers->name = $request->input('name');
        $Passengers->genderId = $request->input('genderId');
        $Passengers->email = $request->input('email');
        $Passengers->mobile = $request->input('mobile');
        //$Passengers->ProfileImage = $request->input('ProfileImage');
        $Passengers->loginStatusId = $request->input('loginStatusId');
        $Passengers->deviceType = $request->input('deviceType');
        $Passengers->validityId = $request->input('validityId');
        $Passengers->save();

        return redirect('/Passengers')->with('success', 'Done successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $Select_db = DB::table('passengers')
            ->select('passengers.id as id', 'name', 'lkp_gender.id as genderId', 'lkp_gender.gender as gender_name', 'email', 'mobile', 'loginStatusId', 'lkp_login.status as loginStatus_name', 'passengers.created_at', 'passengers.updated_at', 'deviceType', 'deviceType_name', 'validityId', 'lkp_validity.status as validity_name', 'profileImage', 'passengerwallet.totalPay', 'passengerwallet.credit', 'due')
            ->leftJoin('lkp_devicetype', 'passengers.deviceType', '=', 'lkp_devicetype.id')
            ->leftJoin('lkp_login', 'passengers.loginStatusId', '=', 'lkp_login.id')
            ->leftJoin('lkp_gender', 'passengers.genderId', '=', 'lkp_gender.id')
            ->leftJoin('passengerwallet', 'passengers.id', '=', 'passengerwallet.passengerId')
            ->leftJoin('lkp_validity', 'passengers.validityId', '=', 'lkp_validity.id')
            ;

        $Select_db->where('passengers.id', $id);
        $Passengers = $Select_db->first();

        //$Passengers = Passengers::find($id);

        return view('Passengers.show')->with('Passengers', $Passengers);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $Passengers = Passengers::where('id', $id)->first();
        return view('Passengers.edit')->with('Passengers', $Passengers);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //'password' => ['required', 'string', 'min:8', 'confirmed'],
        /* $this->validate($request, [
             'name' => ['required', 'string', 'max:255'],
             'email' => ['required', 'string', 'email', 'max:255'],

         ]);
        */
        $Passengers = Passengers::where('id', $id)->first();
        $Passengers->name = $request->input('name');
        $Passengers->genderId = $request->input('genderId');
        $Passengers->email = $request->input('email');
        $Passengers->mobile = $request->input('mobile');
        //$Passengers->ProfileImage = $request->input('ProfileImage');
        $Passengers->loginStatusId = $request->input('loginStatusId');
        $Passengers->deviceType = $request->input('deviceType');
        $Passengers->validityId = $request->input('validityId');
        $Passengers->save();

        return redirect('/Passengers')->with('success', 'Done successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {

        $Passengers = Passengers::where('id', $id)->first();
        // if(auth()->Passengers()->id !== $Passengers->Passengers_id){
        //    return redirect('/Passengers')->with('error','Unauthorized');
        // }

        if ($Passengers->logo != 'noImage.jpg') {
            Storage::delete('public/app/storage' . $Passengers->logo);

        }

        $Passengers->delete();

        return redirect('/Passengers')->with('success', 'Done successfully');
    }
}
