<?php

namespace App\Http\Controllers;


use App\Settings;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;

class SettingsController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $lkp_languages = DB::select('SELECT * from lkp_languages');
        $Settings = collect(DB::select('SELECT * from lkp_settings_company where companyId='.Auth::user()->companyId))->first();
        return view('Settings.index')->with(compact('Settings'))->with(compact('lkp_languages'));

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        /* $this->validate($request, [
             'name' => ['required', 'string', 'max:255'],
             'email' => ['required', 'string', 'email', 'max:255', 'unique:Settings'],
             'password' => ['required', 'string', 'min:8', 'confirmed'],
         ]);
         */
        $Settings = new Settings;
        $Settings->vat_percentage = $request->input('vat_percentage');
        $Settings->comapany_percentage = $request->input('comapany_percentage');
        $Settings->driver_percentage = $request->input('driver_percentage');
        $Settings->lang1_id = $request->input('lang1_id');
        $Settings->lang2_id = $request->input('lang2_id');
        $Settings->currency = $request->input('currency');
        $Settings->plate_letter_length = $request->input('plate_letter_length');
        $Settings->SMS_URL = $request->input('SMS_URL');
        $Settings->distance = $request->input('distance');
        $Settings->Min_Vehicle_Model = $request->input('Min_Vehicle_Model');
        $Settings->Max_Amount_With_Driver = $request->input('Max_Amount_With_Driver');
        $Settings->Government_Trip_Fee = $request->input('Government_Trip_Fee');
        $Settings->companyId = Auth::user()->companyId;
        $Settings->save();
        return redirect('/Settings')->with('success', 'Done successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function update(Request $request, $id)
    {
        $Settings = Settings::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        $Settings->vat_percentage = $request->input('vat_percentage');
        $Settings->comapany_percentage = $request->input('comapany_percentage');
        $Settings->driver_percentage = $request->input('driver_percentage');
        $Settings->lang1_id = $request->input('lang1_id');
        $Settings->lang2_id = $request->input('lang2_id');
        $Settings->currency = $request->input('currency');
        $Settings->plate_letter_length = $request->input('plate_letter_length');
        $Settings->SMS_URL = $request->input('SMS_URL');
        $Settings->distance = $request->input('distance');
        $Settings->Min_Vehicle_Model = $request->input('Min_Vehicle_Model');
        $Settings->Max_Amount_With_Driver = $request->input('Max_Amount_With_Driver');
        $Settings->Government_Trip_Fee = $request->input('Government_Trip_Fee');
        $Settings->save();
        return redirect('/Settings')->with('success', 'Done successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {

    }
}
