<?php

namespace App\Http\Controllers;

//use App\Trips;
use DB;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;

class TripsController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {

        $lkp_cartypes = DB::select('SELECT id,carName from lkp_cartypes order by carName');
        $lkp_paymenttype = DB::select('SELECT id,paymentType from lkp_paymenttype order by paymentType');
        $lkp_ridestatus = DB::select('SELECT id,rideStatus from lkp_ridestatus order by id');


        $Select_db = DB::table('bookings')->select('bookings.id as id', 'requestId', 'passengerId',
            'passengers.name as passenger_name',
            'bookings.driverId as driverId', 'drivers.name as driver_name',
            'carName', 'pickupAddress', 'destinationAddress', 'pickupLatLong', 'endTripLatLng',
            'finalTripCost', 'totalPay', 'finalDistance', 'waitingTime', 'finalTime', 'rideStartDateTime',
            'rideEndDateTime',
            'paymentTypeId', 'paymentType', 'bookings.rideStatusId', 'rideStatus', 'vehichleId',
            'tripReferenceNumber', 'bookings.created_at', 'bookings.updated_at')
            ->leftJoin('passengers', 'bookings.passengerId', '=', 'passengers.id')
            ->leftJoin('lkp_cartypes', 'bookings.carTypeId', '=', 'lkp_cartypes.id')
            ->leftJoin('lkp_paymenttype', 'bookings.paymentTypeId', '=', 'lkp_paymenttype.id')
            ->leftJoin('lkp_ridestatus', 'bookings.rideStatusId', '=', 'lkp_ridestatus.id')
            ->leftJoin('drivers', 'bookings.driverId', '=', 'drivers.id')
            ->leftJoin('driver_vehicles', 'bookings.vehichleId', '=', 'driver_vehicles.id')
            ->where('bookings.companyId', Auth::user()->companyId);


        if (request()->ajax()) {

            if (!empty($request->filter_passengerId)) {
                $Select_db->where('passengerId', $request->filter_passengerId);
            }
            if (!empty($request->filter_driverId)) {
                $Select_db->where('bookings.driverId', $request->filter_driverId);
            }
            if (!empty($request->filter_vehichleId)) {
                $Select_db->where('bookings.vehichleId', $request->filter_vehichleId);
            }
            if (!empty($request->filter_carTypeId)) {
                $Select_db->where('bookings.carTypeId', $request->filter_carTypeId);
            }
            if (!empty($request->filter_pickupAddress)) {
                $Select_db->whereRaw("UPPER(bookings.pickupAddress) LIKE '%".strtoupper($request->filter_pickupAddress)."%'");
            }
            if (!empty($request->filter_destinationAddress)) {
                $Select_db->whereRaw("UPPER(bookings.destinationAddress) LIKE '%".strtoupper($request->filter_destinationAddress)."%'");
            }
            if (!empty($request->filter_pickupLatLong)) {
                $Select_db->whereRaw("UPPER(bookings.pickupLatLong) LIKE '%".strtoupper($request->filter_pickupLatLong)."%'");
            }
            if (!empty($request->filter_destinationLatLong)) {
                $Select_db->whereRaw("UPPER(destinationLatLong) LIKE '%".strtoupper($request->filter_destinationLatLong)."%'");
            }
            if (!empty($request->filter_finalTripCost)) {
                $Select_db->where('bookings.finalTripCost', $request->filter_finalTripCost);
            }
            if (!empty($request->filter_totalPay)) {
                $Select_db->where('bookings.totalPay', $request->filter_totalPay);
            }
            if (!empty($request->filter_finalDistance)) {
                $Select_db->where('bookings.finalDistance', $request->filter_finalDistance);
            }
            if (!empty($request->filter_finalTime)) {
                $Select_db->where('bookings.finalTime', $request->filter_finalTime);
            }
            if (!empty($request->filter_rideStartDateTime)) {
                $Select_db->where('bookings.rideStartDateTime', $request->filter_rideStartDateTime);
            }
            if (!empty($request->filter_rideEndDateTime)) {
                $Select_db->where('bookings.rideEndDateTime', $request->filter_rideEndDateTime);
            }
            if (!empty($request->filter_paymentTypeId)) {
                $Select_db->where('bookings.paymentTypeId', $request->filter_paymentTypeId);
            }
            if (!empty($request->filter_rideStatusId)) {
                $Select_db->where('bookings.rideStatusId', $request->filter_rideStatusId);
            }
            if (!empty($request->filter_tripReferenceNumber)) {
                $Select_db->where('bookings.tripReferenceNumber', $request->filter_tripReferenceNumber);
            }
            if (!empty($request->filter_waitingTime)) {
                $Select_db->where('bookings.waitingTime', $request->filter_waitingTime);
            }

            if (!empty($request->filter_created_at)) {
                $filter_created_at = explode(" - ", $request->filter_created_at);
                $Select_db->whereRaw("CAST(bookings.created_at as date) between STR_TO_DATE('$filter_created_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_created_at[1]','%d/%m/%Y')");
            }
            if (!empty($request->filter_updated_at)) {
                $filter_updated_at = explode(" - ", $request->filter_updated_at);
                $Select_db->whereRaw("CAST(bookings.updated_at as date) between STR_TO_DATE('$filter_updated_at[0]','%d/%m/%Y') and STR_TO_DATE('$filter_updated_at[1]','%d/%m/%Y')");
            }


            $data = $Select_db->get();
            return datatables()->of($data)->make(true);
        }

        $data = $Select_db->get();
        //$Trips = Trips::orderBy('created_at', 'desc')->paginate(10);
        return view('Trips.index')->with(compact('lkp_cartypes'))->with(compact('lkp_paymenttype'))->with(compact('lkp_ridestatus'));
        //return view('custom_search', compact('country_name'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {


    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //return $id;

        $Trips = DB::table('bookings')
            ->select('bookings.id as id', 'requestId', 'passengerId', 'passengers.name as passenger_name',
                'bookings.driverId as driverId', 'drivers.name as driver_name',
                'carName', 'pickupAddress', 'destinationAddress', 'pickupLatLong', 'destinationLatLong',
                'endTripLatLng',
                'finalTripCost', 'totalPay', 'finalDistance', 'waitingTime', 'finalTime', 'rideStartDateTime',
                'rideEndDateTime',
                'paymentTypeId', 'paymentType', 'bookings.rideStatusId', 'rideStatus', 'vehichleId',
                'tripReferenceNumber', 'bookings.created_at', 'bookings.updated_at',
                'lkp_carbrands.name_en as Brand_En', 'lkp_carbrandsub.name_en as BrandSub_En', 'model', 'colour',
                'sequenceNumber',
                DB::raw("CONCAT(plateLetterRight,' ',plateLetterMiddle,' ',plateLetterLeft,' ',plateNumber )  AS plate"))
            ->leftJoin('passengers', 'bookings.passengerId', '=', 'passengers.id')
            ->leftJoin('lkp_cartypes', 'bookings.carTypeId', '=', 'lkp_cartypes.id')
            ->leftJoin('lkp_paymenttype', 'bookings.paymentTypeId', '=', 'lkp_paymenttype.id')
            ->leftJoin('lkp_ridestatus', 'bookings.rideStatusId', '=', 'lkp_ridestatus.id')
            ->leftJoin('drivers', 'bookings.driverId', '=', 'drivers.id')
            ->leftJoin('driver_vehicles', 'bookings.vehichleId', '=', 'driver_vehicles.id')
            ->leftJoin('lkp_carbrands', 'driver_vehicles.carbrand_Id', '=', 'lkp_carbrands.id')
            ->leftJoin('lkp_carbrandsub', 'driver_vehicles.carbrandsub_Id', '=', 'lkp_carbrandsub.id')
            ->leftJoin('lkp_vehicleplatetype', 'driver_vehicles.plateTypeId', '=', 'lkp_vehicleplatetype.id')
            ->leftJoin('lkp_validity', 'driver_vehicles.validityId', '=', 'lkp_validity.id')
            ->where('bookings.companyId', Auth::user()->companyId)
            ->where('bookings.id', $id)
            ->first();
        return view('Trips.show')->with(compact('Trips'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {

    }

}
