<?php

namespace App\Http\Controllers;

use DB;
use App\UsersRole;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;

//use Illuminate\Support\Facades\DB;

class UsersRoleController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $Select_db = DB::table('users_role')
            ->select('users_role.id as id', 'role_name',
                'users_role.created_at', 'users_role.updated_at')
            ->where('users_role.companyId', Auth::user()->companyId)
            ->get();
        if (request()->ajax()) {

            //$data = $Select_db->get();
            return datatables()->of($Select_db)->make(true);
        }

        //$data = $Select_db->get();


        return view('UsersRole.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        //$UsersRole = DB::select('SELECT * from users_role');
        return view('UsersRole.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $this->validate($request, [
            'role_name' => ['required', 'string', 'max:255'],
        ]);

        $UsersRole = new UsersRole;
        $UsersRole->role_name = $request->input('role_name');
        $UsersRole->companyId = Auth::user()->companyId;
        $UsersRole->save();

        return redirect('/UsersRole')->with('success', 'Done successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

        $Select_db = DB::table('users_role')
            ->select('users_role.id as id', 'role_name',
                'users_role.created_at', 'users_role.updated_at')
            ->where('users_role.companyId', Auth::user()->companyId)
            ->where('users_role.id', $id);
        $UsersRole = $Select_db->first();

        return view('UsersRole.show')->with('UsersRole', $UsersRole);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

        $UsersRole = DB::select(DB::raw('SELECT * from users_role where companyId=' . Auth::user()->companyId . ' and id=' . $id))[0];
        return view('UsersRole.edit')->with('UsersRole', $UsersRole);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //'password' => ['required', 'string', 'min:8', 'confirmed'],
        $this->validate($request, [
            'role_name' => ['required', 'string', 'max:255'],
        ]);

        $UsersRole = UsersRole::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        $UsersRole->role_name = $request->input('role_name');
        $UsersRole->save();

        return redirect('/UsersRole')->with('success', 'Done successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $UsersRole = UsersRole::where('id', $id)->where('companyId', Auth::user()->companyId)->first();
        // if(auth()->user()->id !== $UsersRole->user_id){
        //    return redirect('/UsersRole')->with('error','Unauthorized');
        // }

        if ($UsersRole->logo != 'noImage.jpg') {
            Storage::delete('public/app/storage' . $UsersRole->logo);

        }

        $UsersRole->delete();

        return redirect('/UsersRole')->with('success', 'Done successfully');
    }


}
