<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8" />
        <title>Log In | Muhrah</title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta content="A fully featured admin theme which can be used to build CRM, CMS, etc." name="description" />
        <meta content="Coderthemes" name="author" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <!-- App favicon -->
        
        <link rel="shortcut icon" href="{{asset("/images/faviconico")}}">

		<!-- App css -->
		<link href="{{asset("/css/bootstrap.min.css")}}" rel="stylesheet" type="text/css" id="bs-default-stylesheet" />
		<link href="{{asset("/css/app.min.css")}}" rel="stylesheet" type="text/css" id="app-default-stylesheet" />
        
        <!-- Custom Stylesheet -->
		<link href="{{asset("/css/style.css")}}" rel="stylesheet" type="text/css" id="custom-stylesheet" />

		<!-- icons -->
		<link href="{{asset("/css/icons.min.css")}}" rel="stylesheet" type="text/css" />

    </head>

    <body class="auth-screenbg">
        <div class="account-pages mt-5 mb-5">
            <div class="container">
                <div class="row ">
                    <!--Hero Image-->
                    <div class="col-md-7 col-lg-7 col-xl-8">
                        <div class="text-center mt-5">
                            <img src="{{asset("/images/Group1467.png")}}" class="img-fluid m-auto">
                        </div>
                    </div>
                    <!--Hero Image-->
                    <div class="col-md-5 col-lg-5 col-xl-4">
                        <div class="card">
                        @include('pages.messages')
                                                                                                  @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif
                            <div class="card-body p-4">
                                <div class="language-switcher text-right">
                                    <a href="#" class="active">ENG</a> | <a href="#" class="">العربیہ</a>
                                </div>
                                <div class="text-left  m-auto">
                                    <h2>We Are <strong>Muhrah</strong></h2>
                                    <p class=" mb-4">Welcome Back, Login to your account</p>
                                </div>

                                 <form method="POST" action="{{ route('login') }}" class="login_form">
				@csrf
                                    <div class="form-group input-group-merge mb-3">
                                        <label for="emailaddress">Email address</label>
                                        <div class="input-group">
                                            <input class="form-control" value="{{ old('email') }}" name="email" type="email" id="email" required placeholder="Enter your email" @error('email') is-invalid @enderror">
                                            @error('email')
                                            <span class="form-icon display-none"><i class="far fa-envelope"></i>
                                            <strong>{{ $message }}</strong>
                                            </span>
                                            @enderror
                                        </div>
                                    </div>
                                    
                                    <div class="form-group mb-3">
                                        <label for="password">Password</label>
                                        <div class="input-group ">
                                            <input type="password" name="password" id="password" class="form-control" placeholder="Enter your password" @error('password') is-invalid @enderror">
                                            @error('password')
                                            <span class="form-icon display-none"><i class="fas fa-lock"></i>
                                             <strong>{{ $message }}</strong>
                                            </span>
                                             @enderror
                                        </div>
                                    </div>

                                    <div class="form-group mb-3">
                                        <div class="custom-control custom-checkbox">
                                            <input type="checkbox" name="remember"  class="custom-control-input" id="remember" {{ old('remember') ? 'checked' : '' }}>
                                            <label class="custom-control-label" for="checkbox-signin">{{ __('Remember Me') }}</label>
                                        </div>
                                    </div>

                                    <div class="form-group mb-0 text-center">
                                        <button class="btn btn-primary btn-rounded waves-effect waves-light btn-block" type="submit"> Log In </button>
                                    </div>
                                     @if (Route::has('password.request'))
                                    <p class="mt-4 text-right"> <a href="{{ route('password.request') }}" class=" ml-1"> {{ __('Forgot Your Password?') }}</a></p>
                                    @endif
                                </form>
                            </div> <!-- end card-body -->
                        </div>
                        <!-- end card -->
                    </div> <!-- end col -->
                    
                </div>
                <!-- end row -->
            </div>
            <!-- end container -->
        </div>
        <!-- end page -->

        <!-- Vendor js -->
        <script src="{{asset("/js/vendor.min.js")}}"></script>

        <!-- App js -->
        <script src="{{asset("/js/app.min.js")}}"></script>
        
    </body>
</html>
