<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Http\Controllers\Auth\ForgotPasswordController;
use App\Http\Controllers\Auth\LoginController;
Route::get('/', 'PagesController@index')->name('main');
Route::get('/home', 'PagesController@index');

Route::get('/about', 'PagesController@about');
Route::resource('/UsersRole', 'UsersRoleController');
Route::resource('/Users', 'UsersController');
Route::get('/UsersPrivilage/{id}', 'UsersPrivilegeController@index');
Route::post('/UsersPrivilage', 'UsersPrivilegeController@store');
Route::resource('/Passengers', 'PassengersController');
Route::get('/PassengerChart', 'PassengerChartController@index');
Route::resource('/Drivers', 'DriversController');
Route::resource('/DriverVehicles', 'DriverVehiclesController');
Route::get('/getcarbrandsub/{barand_id}', 'DriverVehiclesController@getcarbrandsub');
Route::get('/DriverWindow', 'DriverWindowController@index');
Route::resource('/BookingRequests', 'BookingRequestsController');
Route::get('/PassengerWindow', 'PassengerWindowController@index');
Route::resource('/Trips', 'TripsController');
Route::get('/DriverVehicleWindow', 'DriverVehiclesController@index');
Route::get('driverTracking', 'HomeController@driverTracking');
Route::resource('/CarTypes', 'CarTypesController');
Route::get('/ResetPass/{id}', 'UsersController@ResetPass');
Route::POST('/SaveResetPass', 'UsersController@SaveResetPass');
Route::resource('/BookingReceipts', 'BookingReceiptsController');
Route::get('/RequestNotifications/{id}', 'BookingRequestsController@RequestNotifications');
Route::resource('/Settings', 'SettingsController');
Route::resource('/DriverVerification', 'DriverVerificationController');
Route::resource('/PassengerVerification', 'PassengerVerificationController');
Route::get('/DriverChart', 'DriverChartController@index');
Route::get('/DriverVehicleChart', 'DriverVehicleChartController@index');
Route::get('/BookingRequestChart', 'BookingRequestChartController@index');
Route::get('/TripChart', 'TripChartController@index');
Route::resource('/DailyDriverRegistration', 'DailyDriverRegistrationController');
Route::resource('/DailyPassengerRegistration', 'DailyPassengerRegistrationController');
Route::resource('/Orders', 'OrdersController');
Route::resource('/OrderReceipts', 'OrderReceiptsController');
Auth::routes();
Route::post('/verify_user', [ForgotPasswordController::class, 'verify_user'])->name('verify_user');
Route::get('/reset_password/{user_id}', [ForgotPasswordController::class, 'reset_password'])->name('reset_password');
Route::post('/update_password', [ForgotPasswordController::class, 'update_password'])->name('update_password');
Route::get('/logout', [LoginController::class, 'logout_view'])->name('logout_view');
